from pyknic.resources.tiledtmxloader import ImageLoaderPyglet

import pyglet
import logging
log = logging.getLogger('anims')

def GetAnimFrames(image, sx, sy):
    log.info("GetAnimFrames" +str((image, sx, sy)))
    
    ildr = ImageLoaderPyglet()

    anim_images = ildr.load_image_parts( image, margin = 0, spacing = 0, tile_width = sx, tile_height = sy)

    log.debug( "Got frames:"+str(len(anim_images)))
    return anim_images

def GetAnimSeqFromFile(name, dim, timeperframe = 0.1, loop = True):
        seq = GetAnimFrames(name, dim[0], dim[1])
        res = pyglet.image.Animation.from_image_sequence(seq,  period = timeperframe, loop = loop)
        return res
    
def GetFramesFromFile(name, dim):
        seq = GetAnimFrames(name, dim[0], dim[1])
        res = []
        for img in seq:
            res.append(pyglet.image.Animation.from_image_sequence([img],  period = 0.1, loop = True))
        return res
