
from boid import Boid
from health import Health
from fsm import FSM

import logging
log = logging.getLogger('bird')
from splode import  Blood
from cocos.actions import Delay, CallFuncS, FadeOut, CallFunc
from cocos.sprite import Sprite

class Bird(Boid, Health, FSM):
    def __init__(self, sg, flock, name, boid_splat, cfg):
        Boid.__init__(self, flock, name, cfg)
        Health.__init__(self, sg, type = "bird", max_health = cfg.default_health)
        FSM.__init__(self)
        
        self.last_poop_time = 0
        self.last_attack_time = 0
        self.boid_splat = boid_splat
        # idle      - Normal state (hovering around target)
        # perched   - Sitting on the ground
        # attacking - Attacking a human

        self.add_state("idle",      "ground",           "perched",      self.do_idle)
        self.add_state("perched",   "move",             "idle",         self.do_idle)
        self.add_state("idle",      "attack",           "attacking",    self.do_idle)
        self.add_state("attacking", "attack_complete",  "idle",         self.do_idle)
   
    def PositionUpdate(self, dt):
        Boid.PositionUpdate(self, dt)
        Health.update(self, dt)
        
    def die(self):
        #if self.dead is True:
        #    log.error(self.type + " dead ALREADY "+str(self))
        #else:    
        log.info(self.type+" dying,"+str(self))
        
        if self not in self.flock.boids:
            log.info("huh?")
        else:
            self.flock.boids.remove(self)   

        # handled by world
        #self.parent.world.birds.remove(self)   
        #splode = Blood()  
        #splode.position = self.position
        #self.add(splode, z = 10)  
        
        splat = Sprite(self.boid_splat)
        
        self.parent.add(splat)
        splat.position = self.position
        splat.do(Delay(0.4)+CallFuncS(splat.parent.remove))
        Health.die(self)
    
    def do_idle(self):
        pass