import logging
log = logging.getLogger('FSM')
 

# Modified version of http://wiki.python.org/moin/FiniteStateMachine
class FSM(object):
    def __init__(self):
        self.states = {}
        self.state = None
        self.activity = None
        
    def add_state(self, state, input, newstate, transition_action):
        self.states[(state, input)] = (newstate, transition_action)
    
    def execute_state(self, input):
        state_input = (self.state, input)
        state_none = (self.state, None)
        
        newstate, action = None, None
        
        # exact state match?
        if self.states.has_key(state_input):
            newstate, action = self.states[state_input]
        # no, how about a None (catch-all) match?
        elif self.states.has_key(state_none):
            newstate, action = self.states[state_none]
 
        log.debug( '%s -- State: %s / Input: %s /  Next State: %s / Action: %s\n' % (self.__class__,self.state, input, newstate, action))
        
        if action is not None:
            self.activity = action
            #apply(action, (self.state, input))
        if newstate is not None:
            log.debug("Setting newstate:"+newstate)
            self.state = newstate
        
    def set_state(self, state):
        self.state = state
        self.execute_state(state)
        
    def update(self, dt):
        log.debug(str(self.__class__)+" update:"+self.state+str(dt))
        if self.activity is not None:
            log.debug( "activity "+str(self.activity))
            self.activity()
