import cocos
from pixel_collide import SpriteCollision

from constants import *

import logging
log = logging.getLogger('health')

class Health(object):
    def __init__(self, sg, type= "none", max_health = 3):
        self.sg = sg
        self.kills = 0
        self.max_health = max_health
        self.health = max_health
        self.type = type
        self.dead = False
        if DEBUG:
            self.heath_label = cocos.text.Label('')
            self.add(self.heath_label)
            self.schedule(self.update_heath_label)

        # Pixel perfect
        self.collision = SpriteCollision(self) 
        
        self.x = int(self.x)
        self.y = int(self.y)
       
        # Broad faze
        self.sg.add_item(self)
         
                  
    def update_heath_label(self,dt):
        self.heath_label.element.text = str(self.health)+":"+str(self.kills)
    
    def update(self, dt):
        if self.x>0 and self.y >0 and self.x<self.sg.bounds.width and self.y<self.sg.bounds.height:
            self.x = int(self.x)
            self.y = int(self.y)
            
            if self.qnode is None:
                self.sg.add_item(self)
            else:
                self.qnode.move_item(self)
            #self.sg.move_item(self)
            
    def die(self, dontRemove = False): 
        if self.dead is True:
            log.error(self.type + " dead ALREADY "+str(self))
        else:    
            self.unschedule(self.update_heath_label)
            log.info(self.type + " DEAD.")
            
            if dontRemove is False:
                # Remove from visible
                self.parent.remove(self)
            
            # Remove from collision tests
            self.qnode.remove(self)
            
            self.dead = True
        
    
    def hurt(self, amt = 1):
        if self.health > 0:
            self.health = int(self.health - amt) # kill off any . blah
            if self.health <= 0:
                self.die()
                return True
        
        return False