"""Main starter module.

The DEBUG constant can be safely assumed set by the time this module is
imported.

"""

from __future__ import division


import random, math
import data


import config
from common import *
from constants import *

import cocos
import cocos.scene
from cocos.sprite import Sprite
from cocos.director import director

import yaml

import gethigh

from menu_main  import MainMenu
import datetime
from screen_config import ConfigMenu
from screen_intro import IntroLayer
from cocos.scenes.transitions import *
from cocos.scene import Scene
from bg_layer import BGLayer
import logging
log = logging.getLogger('main')
import random, datetime, math
 
from screen_name import NameMenu
def run():
    
    director.init(caption=CAPTION, width=1024, height=400, resizable=False )

 
    mainmenu = Scene(BGLayer("main"), MainMenu())
    intro = Scene(IntroLayer())


    director.window.set_fullscreen(config.fullscreen)

    if config.playerseed == "": # first time this person has run the game
            print "First time run generating seed"
            config.playerseed = str(random.uniform(0, 99999999))+":"+datetime.datetime.now().strftime("%Y%m%d-%H%M%S")
            config.save_option("playerseed", config.playerseed)
            first = Scene (BGLayer("config"),  NameMenu())
            director.run( FadeTransition( first, 5, intro) )
    
    else:   
        director.run( FadeTransition( mainmenu, 5, intro) )
    

def main():
    log.info('Starting main...')  
    
    if config.profile:
        import os, profile
        timestamp = datetime.datetime.now().strftime("%Y%m%d-%H%M%S")
        filename = os.path.join(SCRIPT_DIR, "profile-%s.log" % timestamp)
        profile.runctx("run()", globals(), None, filename)
        import pstats # http://docs.python.org/library/profile.html
        p = pstats.Stats(filename)
        stats = p.sort_stats('time').print_stats(10)#print_callers(10) 
        log.debug(stats)
    else:
        run()
    
    log.info('... DONE')  
    
