
from cocos.director import director
from cocos.layer import Layer,ColorLayer
from cocos.scene import Scene
from cocos.sprite import Sprite
from cocos.scenes.transitions import *
from cocos.actions import *

from cocos.menu import *
from cocos.text import *

from screen_scores  import ScoresLayer
from screen_instructions import InstructionsLayer
from screen_config import ConfigMenu

from menu_back import BackMenu
import config
import random, datetime, math

from bg_layer import BGLayer

from world import World
from hud import Hud
          
class MainMenu( Menu ):

    def __init__(self):
        super( MainMenu, self).__init__() 
        
        self.menu_valign = BOTTOM
        #self.font_item['color'] = (32,16,32,255)
        self.font_item['font_size'] = 16
        self.font_item['color'] = (0,0,0,255)
        #self.font_item_selected['color'] = (32,16,32,255)
        self.font_item_selected['font_size'] = 24
       
        items = []

        items.append( MenuItem('PLAY', self.on_play) )
        items.append( MenuItem('SCORES', self.on_scores) )
        items.append( MenuItem('SETTINGS', self.on_settings) )
        items.append( MenuItem('CREDITS', self.on_credits) )
        items.append( MenuItem('QUIT', self.on_quit) )

        self.create_menu( items)
        
        # Spacing
        """    
        pos = 0
        for menuItem in items:
            menuItem.y =  - pos*20
            pos += 1
        """
            
    def on_enter(self):
        super(MainMenu, self).on_enter() 
               
    def on_play( self ):
        
        director.push(Scene (InstructionsLayer()) )
        
    def on_scores( self ):
        director.push(Scene (BGLayer("scores"), ScoresLayer(), BackMenu()) )
        
    def on_settings( self ):
        director.push(Scene (BGLayer("config"),  ConfigMenu()))#, BackMenu()) )
        
        
    def on_credits( self ):
        director.push(Scene (BGLayer("credits"), BackMenu()) )

    def on_quit(self):
        pyglet.app.exit()
        
    def get_game(self):
        
        main_scene = Scene()
        
        world = World("mini.yaml")
        
        hud = Hud(world)
        
        main_scene.add (world.level)
        
        main_scene.add (hud, z=10)
        
        return main_scene  # Dont push in the menu cause it will consume up and down key events
