
from cocos.layer import ColorLayer
from cocos.director import director
from pyglet.window import key

from cocos.scene import Scene
from bg_layer import BGLayer

from world import World
from hud import Hud
      
from cocos.scenes.transitions import *
from cocos.actions import *

class InstructionsLayer( ColorLayer):

    is_event_handler = True #: enable pyglet's events

    def __init__(self):

        w,h = director.get_window_size()
        super( InstructionsLayer,self).__init__( 2,44,55,22)
        
        self.page = 0
        
        self.pages = [
                      BGLayer("instructions1"),
                      BGLayer("instructions2"),
                      BGLayer("instructions3"),
                      BGLayer("instructions4"),
                      BGLayer("instructions5"),
                      ]
        
        for p in self.pages:
            self.add(p)
            p.visible = False
            
        self.pages[0].visible = True
        print "on page",self.page
    def on_enter( self ):
        super(InstructionsLayer,self).on_enter()

    def on_key_press( self, k, m ):
        if k  == key.ESCAPE:
            director.scene.end()
            return True
        if k in (key.ENTER, key.SPACE):
            self.next_page()
            return True

    def on_mouse_release( self, x, y, b, m ):
        self.next_page()
        return True
    
    def next_page(self):
        self.pages[self.page].visible = False
        self.page += 1
        if (self.page >= len(self.pages)):
            self.pages[self.page-1].do(FadeOut(1))
            self.page = 0
            #director.scene.end()# pop()
            director.replace( FadeTransition( self.get_game() , 2, self) )
        else:
            self.pages[self.page].visible = True
            print "on page",self.page
            
 
    def get_game(self):
        
        main_scene = Scene()
        
        world = World("mini.yaml")
        
        hud = Hud(world)
        
        main_scene.add (world.level)
        
        main_scene.add (hud, z=10)
        
        return main_scene # Dont push in the menu cause it will consume up and down key events
        

    