

from operator import setslice

from cocos.director import director
from cocos.layer import *
from cocos.scene import Scene
from cocos.scenes.transitions import *
from cocos.actions import *
from cocos.sprite import *
from cocos.menu import *
from cocos.text import *

import pyglet
from pyglet import gl, font
from pyglet.window import key

import gethigh


import config
from cocos.sprite import Sprite
from cocos.layer import Layer,ColorLayer

class ScoresBG( Layer ):
    def __init__(self):
        Layer.__init__(self)
        bg = Sprite("data/backgrounds/scores_bg.png")
        self.add(bg)
        

ach_desc = {
            "spacecadet":"Space cadet! Way to go high flyer",
            "ftw":       "You are the winnar",
            "birdseyeview":"High above the clouds.. you have a birds eye view.",
            "freeasabird":"Free as a bird - one bird flock....",
            }
        
class AchIcon(Sprite):
    def __init__(self, sprite, name, position):
        Sprite.__init__(self, sprite)
        self.do( Repeat(Rotate(360, 100)))
        
        if name in ach_desc.keys():
            self.add(Label(ach_desc[name]))
    
    
class ScoresLayer( ColorLayer):

    is_event_handler = True #: enable pyglet's events

    def __init__(self):

        w,h = director.get_window_size()
        super( ScoresLayer,self).__init__( 2,44,55,22)#, width=w, height=h-90)

        self.score_table = None

        """
        title = Label('Achievements for '+config.playername)
        title.position=(w/3.0,100.0)
        self.add(title,z=1)
        """
        self.ach_table = None


    def on_enter( self ):
        super(ScoresLayer,self).on_enter()

        scores = gethigh.GetScores()

        if scores is not None:
            
            if self.score_table:
                self.remove_old()
    
            self.score_table =[]
            for s in scores:
                name = Label( s.name, color  = (0,0,0,255) )
                score = Label( str(s.score) , color  = (0,0,0,255) )
                self.score_table.append( (name,score) )
    
            self.process_table()

        ach = gethigh.GetAchievements(config.playername, config.playerseed)

        if ach is not None:
            offset = 0
            for achievement in ach:
                pic = AchIcon("data/achievements/"+achievement+".png", achievement, (100+offset, 100))
                self.add(pic)
                offset += 100

    def remove_old( self ):
        for item in self.score_table:
            name,score = item
            self.remove(name)
            self.remove(score)
        self.score_table = None

    def process_table( self ):
        w,h = director.get_window_size()

        for idx,item in enumerate(self.score_table):
            name,score = item

            posy = h - 150 - ( (20) * idx )
            
            name.position=( 148, posy)
            score.position=( w-250, posy )

            self.add( name, z=2 )
            self.add( score, z=2 )


    def on_key_press( self, k, m ):
        if k in (key.ENTER, key.ESCAPE, key.SPACE):
            director.scene.end()
            return True

    def on_mouse_release( self, x, y, b, m ):
        director.scene.end()
        return True

