from cocos.scene import Scene
from cocos.director import director
from cocos.euclid import Vector2
from cocos.layer import ColorLayer

import logging
log = logging.getLogger('test_city')
 

from city import City
from humans import Human

from test_flock import TestFlock

def run():
    director.init( resizable=True )
    main_scene = Scene()

    city = City()
    city.set_state("idle")
    
    def crash_plane(dt = 0):
        city.execute_state("crash")

    city.schedule_interval(crash_plane, 2.0)
    
    human = Human()
    #human.pos = Vector2(200,200)
    human.position = 200,200
    human.set_state("idle")
    city.add_human(human)
    #city.scale = 0.2
    ''' 
    human.execute_state("city_annoyed")
    human.execute_state("city_angry")
    
    human.execute_state(None)
    human.execute_state("found_flying")
    human.execute_state("found_rookery")
    human.execute_state("shouldnt_shoot")
    human.execute_state("should_shoot")
    '''
    
    flock = TestFlock("data/images/bird.png", 5) 
    flock.add(city)
    flock.city = city
    main_scene.add(ColorLayer(50,100,255,255))
    main_scene.add( flock )

    #main_scene.add( city )

    director.run( main_scene )
    
if __name__ == "__main__":
    run()
