from cocos.scene import Scene
from cocos.director import director
from cocos.euclid import Vector2

import data
from common import *
from constants import *
import config

import logging
log = logging.getLogger('test_level')
from world import World
from hud import Hud

def run():
    log.info("Starting main")
    if config.profile:
        log.info("Starting profiler")
        import os, profile
        import datetime
        timestamp = datetime.datetime.now().strftime("%Y%m%d-%H%M%S")
        filename = os.path.join(SCRIPT_DIR, "profile-%s.log" % timestamp)
        profile.runctx("runGame()", globals(), None, filename)
        import pstats # http://docs.python.org/library/profile.html
        p = pstats.Stats(filename)
        stats = p.strip_dirs().sort_stats('cumulative').print_stats(20)#print_callers(10) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('cumulative').print_callers(20) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('time').print_stats(20)#print_callers(10) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('time').print_callers(20) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('calls').print_stats(20)#print_callers(10) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('calls').print_callers(20) 
        log.debug(stats)
    else:
        log.info("Not profiling")
        runGame()
        
def runGame():
    director.init( caption=CAPTION, width=1024, height=400, resizable=True )
    main_scene = Scene()
    
    world = World("mini.yaml")
    
    hud = Hud(world)
    
    main_scene.add (world.level)
    
    main_scene.add (hud, z=10)
 
    director.run( main_scene )
    
if __name__ == "__main__":
    director.init( caption=CAPTION, width=1024, height=768, resizable=True )
    run()

    
