from cocos.scene import Scene
from cocos.director import director
from cocos.euclid import Vector2
from cocos.layer import ColorLayer, Layer
from cocos.sprite import Sprite

import data
from common import *
from constants import *
import config
from splode import Smoke,Splode,Blood

import logging
log = logging.getLogger('test_world')
import pyglet
#from world import World
from anims import GetAnimSeqFromFile,GetFramesFromFile
import math
def run():
    log.info("Starting main")
    if config.profile:
        log.info("Starting profiler")
        import os, profile
        import datetime
        timestamp = datetime.datetime.now().strftime("%Y%m%d-%H%M%S")
        filename = os.path.join(SCRIPT_DIR, "profile-%s.log" % timestamp)
        profile.runctx("runGame()", globals(), None, filename)
        import pstats # http://docs.python.org/library/profile.html
        p = pstats.Stats(filename)
        stats = p.strip_dirs().sort_stats('cumulative').print_stats(20)#print_callers(10) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('cumulative').print_callers(20) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('time').print_stats(20)#print_callers(10) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('time').print_callers(20) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('calls').print_stats(20)#print_callers(10) 
        log.debug(stats)
        stats = p.strip_dirs().sort_stats('calls').print_callers(20) 
        log.debug(stats)
    else:
        log.info("Not profiling")
        runGame()
from cocos.actions import *
class Test(Layer):    
    is_event_handler = True # for actions to work
    def __init__(self):
        Layer.__init__(self)
 
            
        self.walk_left_seq = GetAnimSeqFromFile("data/images/hunter_walk_left.png",(100,100))        
        self.shoot_left_seq = GetFramesFromFile("data/images/hunter_shoot_left.png",(100,100))#,  timeperframe = None,loop = False)
        self.walk_right_seq = self.walk_left_seq.get_transform(flip_x = True)
        
        #self.shoot_left_seq = seq
        print self.shoot_left_seq
        #self.shoot_left_seq = seq.from_image_sequence(loop = False,  period = None)#
        
        #self.shoot_left_seq = pyglet.image.Animation.from_image_sequence(seq, loop = False,  period = None) 
        
        #self.walk_right_seq = GetAnimSeqFromFile("data/images/hunter_walk_right.png",(100,100))
        #self.shoot_right_seq = GetAnimSeqFromFile("data/images/hunter_shoot_right.png",(100,100),loop = False)

        x,y = director.get_window_size()
        self.face_left = False    
        self.sprite = Sprite(self.walk_left_seq)
        self.sprite.position = x*0.5, y/2
        self.add(self.sprite)
        self.walk_right_seq = self.walk_left_seq.get_transform(flip_x = True)
        #self.shoot_right_seq = self.shoot_left_seq.get_transform(flip_x = True)#,  period = None)
        self.pos = self.sprite.position
        self.sprite2 = Sprite(self.walk_left_seq)
        self.sprite2.position = x*0.15, y/2
        self.add(self.sprite2)
        

        self.sprite3 = Sprite(self.walk_right_seq)
        self.sprite3.position = x*0.75, y/2
        self.add(self.sprite3)
        
        self.mouse = Vector2(0,0)
        self.me = Vector2(self.sprite.x,self.sprite.y)
        self.press = False
        s = Blood()
        s.position = 200,200
        #s.scale = 0.1
        self.add(s)
        #self.add(Splode())

        
    def on_mouse_motion(self, x, y, dx, dy):
        x, y = director.get_virtual_coordinates (x, y) 
        self.mouse = Vector2(x,y)
        # move gun
        vec = self.me-self.mouse

        deg = (math.degrees(math.atan2(vec.y, vec.x)+math.pi)-90)
        if self.press is False:
            self.sprite.position = self.pos
            if deg <0 and self.face_left is True:
                self.sprite.image = self.walk_right_seq
                self.face_left = False
            if deg >0 and self.face_left is False:
                self.sprite.image = self.walk_left_seq
                self.face_left = True
        else:
            self.sprite.position = self.pos[0]+self.sprite.width/2, self.pos[1]-self.sprite.height/2
            frame = 3- abs(int((deg/90)*4))
            if frame >3:
                frame = 3
            if frame <0:
                frame = 0
            if deg <0 :                
                self.sprite.image = self.shoot_left_seq[frame].get_transform(flip_x = True)
                self.sprite.position = self.pos[0]+self.sprite.width/2, self.pos[1]-self.sprite.height/2
                
            if deg > 0:
                self.sprite.image = self.shoot_left_seq[frame]
                self.sprite.position = self.pos[0]-self.sprite.width/2, self.pos[1]-self.sprite.height/2
            
    def on_mouse_press (self, x, y, buttons, modifiers):       
        self.press = not self.press  
        print "pres:",self.press    

        
def runGame():
    director.init( caption=CAPTION, width=1024, height=768, resizable=True )
    main_scene = Scene()

    main_scene.add(ColorLayer(50,100,255,255))
    
    #world = World()
    main_scene.add( Test()  )
    
  
    #main_scene.add( world )

    director.run( main_scene )
    
if __name__ == "__main__":
    run()

    
